<?php

namespace BackOfficeOptimizer\Services;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\DataSet;

class Lista {
    protected $newCode;
    protected $connection;

    function __construct($newCode, $connection)
    {
        $this->newCode = $newCode;
        $this->connection = $connection;
    }

    public function generateMoreThanOne(DTO\Request $request, DTO\Response $response) {
        $row = $request->getRow();
        $NRORG = $row['NRORG'];
        $codigos = array();
        foreach($row['LIST'] as $item) {
            $nrlista = $this->generateNewList($NRORG, $item);
            array_push($codigos, $nrlista);
        }
        $response->addDataset(new DataSet('data', $codigos));
    }

    public function deleteMoreThanOneList(DTO\Request $request, DTO\Response $response) {
        $row = $request->getRow();
        foreach($row['LIST'] as $nrlista) {
            $this->deleteLista($nrlista);
        }
        $response->addDataset(new DataSet('data', array()));
    }

    public function generateNewList($NRORG, $arrCodigo) {
        $newcodeLista = $this->newCode->getCodeByTableName("LISTA", $NRORG);
        $sql = "INSERT INTO LISTA (NRLISTA, CDLISTA, NRORG, NRORGINCLUSAO, NRORGULTATU, IDATIVO) VALUES (:NRLISTA, :CDLISTA, :NRORG, :NRORG, :NRORG, 'S')";

        foreach($arrCodigo as $codigo) {
            $queryParameters = array(
                "NRLISTA" => $newcodeLista,
                "CDLISTA" => $codigo,
                "NRORG" => $NRORG,
            );

            $query = $this->connection->prepare($sql);
            $query->execute($queryParameters);
        }
        
        return $newcodeLista;
    }

    public function deleteLista($nrLista) {
        $sql = "DELETE FROM LISTA WHERE NRLISTA = :NRLISTA";
        $queryParameters = array("NRLISTA" => $nrLista);
        $query = $this->connection->prepare($sql);
        $query->execute($queryParameters);
    }
}